package edu.unika.aifb.kaon.datalog.evaluation;

/**
 * A filter for the tuples. Tuple filters are typically used to implement selection conditions.
 */
public interface TupleFilter {
    /**
     * Checks whether a tuple matches the filter condition.
     *
     * @param tuple                         the tuple being checked
     * @return                              <code>true</code> if tuples matches the condition
     */
    boolean evaluate(Object[] tuple);
}
