<%@ page contentType="text/html"%>
<%@taglib prefix="pt" uri="/WEB-INF/tags.tld" %>

<pt:relatedentities relation="superconcepts" relatedentities="superconcepts">
<pt:relatedentities relation="subconcepts" relatedentities="subconcepts">
    <% if ( superconcepts.hasNext() || subconcepts.hasNext() ) { %>
        <div style="float: right">
            <pt:phrase key="concept_headline" output="headername">
                <pt:tabtable title="<%=headername%>" titleclass="section_table_tab" contentclass="section_table_content" width="100%">
                    <table width="100%">
                        <pt:onhaselements iteratorname="superconcepts">
                            <!-- insert super concepts -->
                            <tr>
                                <td colspan="2" class="list_title">
                                    <pt:phrase key="concept_superconcepts" />
                                </td>
                            </tr>
                            <pt:ncolumntable iteratorname="superconcepts" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                        </pt:onhaselements>
                        <pt:onhaselements iteratorname="subconcepts">
                            <!-- insert sub concepts -->
                            <tr>
                                <td colspan="2" class="list_title">
                                    <pt:phrase key="concept_subconcepts" />
                                </td>
                            </tr>
                            <pt:ncolumntable iteratorname="subconcepts" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                        </pt:onhaselements>
                    </table>
                </pt:tabtable>
            </pt:phrase>
            <div class="spacer"></div>
        </div>
    <% } %>
</pt:relatedentities>
</pt:relatedentities>

<pt:relatedentities relation="concept_attributes" relatedentities="attributes">
<pt:relatedentities relation="concept_incoming_properties" relatedentities="incomingproperties">
<pt:relatedentities relation="concept_outgoing_properties_no_attributes" relatedentities="outgoingproperties">
    <% if ( attributes.hasNext() || incomingproperties.hasNext() || outgoingproperties.hasNext() ) { %>
        <div style="float: right">
            <pt:phrase key="concept_properties_headline" output="headername">
                <pt:tabtable title="<%=headername%>" titleclass="section_table_tab" contentclass="section_table_content" width="100%">
                    <table width="100%">
                    <pt:onhaselements iteratorname="attributes">
                        <!-- insert attributes -->
                        <tr>
                            <td colspan="2" class="list_title">
                                <pt:phrase key="concept_attributes" />
                            </td>
                        </tr>
                        <pt:ncolumntable iteratorname="attributes" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                    </pt:onhaselements>
                    <pt:onhaselements iteratorname="incomingproperties">
                        <!-- insert incoming properties -->
                        <tr>
                            <td colspan="2" class="list_title">
                                <pt:phrase key="concept_incommingproperties" />
                            </td>
                        </tr>
                        <pt:ncolumntable iteratorname="incomingproperties" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                    </pt:onhaselements>
                    <pt:onhaselements iteratorname="outgoingproperties">
                        <!-- insert outgoing properties -->
                        <tr>
                            <td colspan="2" class="list_title">
                                <pt:phrase key="concept_outgoingproperties" />
                            </td>
                        </tr>
                        <pt:ncolumntable iteratorname="outgoingproperties" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                    </pt:onhaselements>
                    </table>
                </pt:tabtable>
            </pt:phrase>
            <div class="spacer"></div>
        </div>
    <% } %>
</pt:relatedentities>
</pt:relatedentities>
</pt:relatedentities>

<pt:relatedentities relation="instance" relatedentities="entitiesiterator">
    <pt:onhaselements iteratorname="entitiesiterator">
        <div style="float: right">
            <pt:phrase key="concept_instances_headline" output="headername">
                <pt:tabtable title="<%=headername%>" titleclass="section_table_tab" contentclass="section_table_content" width="100%">
                    <table width="100%">
                        <!-- insert instances -->
                        <pt:ncolumntable iteratorname="entitiesiterator" tableexists="true" width="100%" numcolumns="2" elementclass="list_indented" />
                    </table>
                </pt:tabtable>
            </pt:phrase>
            <div class="spacer"></div>
        </div>
    </pt:onhaselements>
</pt:relatedentities>
