package de.fzi.wim.trie.deterministic;

import de.fzi.wim.trie.EntryLocation;

/**
 * An interafece for listening to a Lexicon Checker while it parses a text. Any class implementing
 * this interface is notified whenever the TreeChecker finds a new EntryLocation. No guarantee
 * is made about the sequence in which the entries are found.
 *
 * @author <a href="mailto:zach@fzi.de">Valentin Zacharias</a>
 * @version 19.12.2001
 */
public interface LexiconCheckerListener {

  public void EntryLocationFound(EntryLocation el);

}
