package de.fzi.wim.trie.extractor;

/**
 * An interface for a class that want's to listen to the trie. A object
 * implementing this interface is attached to a node and notified once
 * this node is reached by a pointer.
 *
 * @author <a href=zach@fzi.de>Valentin Zacharias</a>
 */
public interface TrieListener extends java.io.Serializable{

    public void notify(Pointer pointer, int index, String threadID);
    public Object clone();

}
